#ifndef KMEANSBASED_H
#define KMEANSBASED_H
#include "common.h"

//kmeansBased
//float getLogProb(gmm* model, float* X,int nrKeypoints, float* weights );
double getCompactness(cv::Mat centers, float* X,int nrKeypoints,float maxComp);
float getCompactnessSSE(cv::Mat centers, float* XX,int nrKeypoints,float* weights);
float getHistDist(cv::Mat centers, float* X, float* hist, int nrKeypoints);
//sparse
void findSparseHist(float* centers, IplImage* img, Method* mm, std::vector<histbin>* hist);
float getHistDist(histbin* h, int lenh, histbin* g, int leng);
int getSparseHist(float* X, int nrKeypoints, int dim, histbin* hist, float minx, float maxx, int k);
//
void loadFeatures(float* descr, int* nrKeypoints, char* fname);
void applyKmeans(float* centers, IplImage* img, Method* mm, float* hist=0, char* fname=0);
void applyEm(float* X, IplImage* img, Method* m, char* savefname);
void applyCvEm(float* X, IplImage* img, Method* m, char* savefname);
void applyHierClust(float* centers, IplImage* img, Method* mm);

#endif