#include "common.h"
#include "corel5k.h"
params param;
char method_names[5][256];

#ifdef _WIN32
extern "C" { 
void vl_constructor ();
void vl_destructor ();
}
#endif

int main(int argn, char** argv){

	param.mnr = 1;	
	strcpy(method_names[0],"SIFT");
	//strcpy(method_names[0],"color");
	//strcpy(method_names[0],"SIFT");
	//strcpy(method_names[2],"WLD");
		
#ifdef _WIN32
	vl_constructor();
#endif

	//folder should contain an img subfolder with all the images in their folders 1000, 10000, etc.
	//also a data subfolder with all txt files: words, image_nums, etc.
	Corel5k db("d:\\imgdb\\corel5k\\");	
		
	//db.clean(0);	
	//db.readData();
	//db.trainAll();

	int nr;
	for(int bag=50;bag<=500;bag+=50)
	{
		nr = bag/50-1;
		param.setAtr("bag",bag);
		//test with all configurations using the current bag value (number of selected features to compare)
		//db.testAll();
		//save the results for all the 72 configurations
		for(int ti=0;ti<72;ti++)
		{
			param.setAtr("ti",nr*72+ti);
			db.results();
		}
	}	
	printf("Done");
	//results are in the folder __results/method_name.txt

#ifdef _WIN32
	getch();
	vl_destructor();
#endif
	return 0;
}
